//Studio Twinkle ADVRLIB Archive
#include <stdio.h>
#include <stdlib.h>
#include <alloc.h>
#include <string.h>

unsigned char	header[] = { 'A','D','V','R','L','I','B' };

void main( int ac, char **av )
{
	FILE				*in;
	FILE				*out;
	unsigned char		tmp[0x10];
	unsigned char		*buf;
	unsigned char		*filebuf;
	unsigned long		header_length = 0L;
	unsigned int		file_count = 0;
	unsigned long		file_ed = 0L;

	char				header_filename[13];
	unsigned long		header_filest = 0L;
	unsigned long		header_fileed = 0L;
	unsigned long		header_filesize = 0L;

	unsigned long		nowsize = 0L;

	unsigned int		i;

	printf( "Studio Twinkle ADVRLIB Divider 061119 (c)Fac.KUROHANE\n" );

	if( ac == 1 )
	{
		printf( "usage: ADVRDIV <filename>\n" );
		return;
	}

	in = fopen( av[1], "rb" );
	if( in == NULL )
	{
		printf( "error: can't open %s\n", av[1] );
		return;
	}

	fseek( in, 0, SEEK_SET );
	fread( tmp, 0x10, 1, in );
	if( !memcmp( header, tmp, 8 ))
	{
		printf( "error: not ADVRLIB format.\n" );
		fclose( in );
		return;
	}

	printf( "filename: %s\n", av[1] );

	//filesize
	file_ed = *( unsigned long *)( tmp + 0x0C );
	printf( "file_size: %lu bytes\n", file_ed );

	//file_count
	file_count = *( unsigned int *)( tmp + 0x0A );
	printf( "file_count: %u\n", file_count );

	//Header size
	header_length = file_count * 0x10 + 0x10;
	printf( "header_length: %lu(%04lX)\n",
		header_length,
		header_length
	);

	//Read Header
	buf = ( unsigned char *)calloc( 1, header_length );
	fread( buf, header_length, 1, in );

	printf( "\n" );

	for( i = 0; i != file_count; i++ )
	{
		memset( header_filename, 0, 13 );

		memcpy( header_filename, buf + i * 0x10, 12 );
		header_filest = ftell( in );
		header_filesize = *( unsigned long *)( buf + i * 0x10 + 0x0C );
		header_fileed = header_filest + header_filesize;

		printf( "%03d %-12s %08lX-%08lX (%lu) ",
			i + 1,
			header_filename,
			header_filest,
			header_fileed,
			header_filesize
		);

		out = fopen( header_filename, "wb" );
		if( out == NULL )
		{
			printf( "error: can't write %s\n", header_filename );
			goto end;
		}

		fseek( in, header_filest, SEEK_SET );

		filebuf = ( unsigned char * )calloc( 1, 32768 );	//32k
		nowsize = header_filesize;

		while( !( nowsize < 32769 ))
		{
			fread( filebuf, 32768, 1, in );
			fwrite( filebuf, 32768, 1, out );
			nowsize -= 32768;
			printf( "." );
		}
		fread( filebuf, nowsize, 1, in );
		fwrite( filebuf, nowsize, 1, out );

		fclose( out );
		printf( ".\n" );
		free( filebuf );
	}

	printf( "\n" );
	printf( "complete.\n" );

end:;
	free( buf );
	fclose( in );

	return;
}
